
<html>
	<head>
		<meta charset="utf-8"/>
        
		<meta http-equiv="X-UA-Compatible" content="chrome=1"/>
        
		<title>Tala Keeper by Srikumar Subramanian</title>
        
		<link rel="canonical" href="http://talakeeper.org/talas.html"/>
        
		<link href="bootstrap/css/bootstrap.min.css" rel="stylesheet"/>
        
		<style>
.page-header {
    margin-bottom: 0px;
    padding-bottom: 5px;
}
.faq h3 {
    color: darkslategrey;
}
.faq h4 {
    color: slategrey;
}
.faq p {
    color: dimgrey;
}
.faq p strong {
    color: darkslategrey;
}
.by {
    color: lightgrey;
    font-size: 11pt;
    font-weight: normal;
    text-align: right;
}
.copyright {
    font-size: 9pt;
    font-weight: normal;
    color: lightgrey;
    float: right;
}
.breadcrumb {
    background: white;
    padding: 10px;
}
.breadcrumb li a {
    color: slategrey;
}
.breadcrumb .thispage {
    color: darkslategrey;
    font-weight: bold;
}            
</style>
        
		<meta name="viewport" content="width=device-width, initial-scale=1, user-scalable=yes"/>
        
		<script>
    (function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
            (i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
        m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
    })(window,document,'script','//www.google-analytics.com/analytics.js','ga');

    ga('create', 'UA-37337144-2', 'sriku.org');
    ga('send', 'pageview');
</script>
    
	</head>
    
	<body style="background:white;color:black">
		<div class="container">
			<div class="page-header">
				<h1>Tala Keeper 
					<small>A programmable visual metronome</small>
                    
					<span style="float:right">
						<a href="https://itunes.apple.com/us/app/tala-keeper/id614784414?mt=8&uo=4" target="itunes_store" style="display:inline-block;overflow:hidden;background:url(http://development-linkmaker.itunes.awcloud.net//htmlResources/assets/en_us//images/web/linkmaker/badge_appstore-lrg.png) no-repeat;width:135px;height:40px;@media only screen{background-image:url(http://development-linkmaker.itunes.awcloud.net//htmlResources/assets/en_us//images/web/linkmaker/badge_appstore-lrg.svg);}"></a>
					</span>
                
				</h1>
                
				<span style="float:right; text-align:left; margin-top:8pt; width:96pt;">
					<span style="position:absolute;">
						<div class="addthis_toolbox addthis_default_style addthis_16x16_style">
							<a class="addthis_button_facebook"></a>
            
							<a class="addthis_button_twitter"></a>
            
							<a class="addthis_button_linkedin"></a>
            
							<a class="addthis_button_pinterest_share"></a>
            
							<g:plusone size="small"></g:plusone>
        
						</div>
        
						<script type="text/javascript" src="//s7.addthis.com/js/300/addthis_widget.js#pubid=ra-51aab4ac106425ba"></script>
        
						<script type="text/javascript">
    (function() {
     var po = document.createElement('script'); po.type = 'text/javascript'; po.async = true;
     po.src = 'https://apis.google.com/js/plusone.js';
     var s = document.getElementsByTagName('script')[0]; s.parentNode.insertBefore(po, s);
     })();
</script>
        
    
					</span>

				</span>
            
			</div>
            
			<div class="row" style="margin:2em">
				<script src="lib/require.min.js"></script>    
    
				<script src="lib/steller_v0.5.1.min.js"></script>
    
				<script src="tk3.js"></script>
    
				<div class="span5" id="taladisplay"></div>
    
				<div class="span5">
					<section class="span5">
						<header>
							<h4>
								<small>Pattern:</small> 
								<span id="talaname"></span> 
								<small>at 
									<span id="talatempo"></span>bpm
								</small>
							</h4>
        
						</header>
        
					</section>
        
					<div class="row">
						<div class="span2">
							<h4>Common Talas</h4>
                
							<ul id="common_talas">
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrlrlr&name=Adi%20Tala"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrrlrrrrlrlr&name=Ata%20Tala%20(Kanda)"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=120&pat=l_rr_&name=Kanda%20Capu%20Tala"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=120&pat=ll_r_r_&name=Misra%20Capu%20Tala"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrr&c=n&name=Rupaka%20Tala"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=120&pat=l___r_rr_&name=Sankirna%20Capu%20Tala"></a>
								</li>
                
							</ul>
            
						</div>

            
						<div class="span3">
							<h4>Alankara Talas</h4>
                
							<ul id="alankara_talas">
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrlrlrrrlrrr&name=Catusra%20Dhruva"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrlrlrrr&name=Catusra%20Matya"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrlrrr&name=Catusra%20Rupaka"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrrrrllr&name=Misra%20Jampa"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrlrlr&name=Tisra%20Triputa"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrrrlrrrrlrlr&name=Kanda%20Ata"></a>
								</li>
                    
								<li>
									<a href="tala://talakeeper.org/tk3?bpm=80&pat=lrrr&name=Catusra%20Eka"></a>
								</li>
                
							</ul>
            
						</div>
        
					</div>

        
					<div class="row">
						<h4>Systematic Talas</h4>
            
						<div>
							<div id="full_systematic_name" style="margin:1em" s>
								<div id="jati" class="kssmenu" data-value="lrrr">
									<span class="kssmenu_value">Catusra</span>
                        
									<div class="kssmenu_options">
										<a data-value="lrr">Tisra (3)</a>
                            
										<a data-value="lrrr" data-selected="yes">Catusra (4)</a>
                            
										<a data-value="lrrrr">Kanda (5)</a>
                            
										<a data-value="lrrrrrr">Misra (7)</a>
                            
										<a data-value="lrrrrrrrr">Sankirna (9)</a>
                        
									</div>
                    
								</div>
                    jati
                    
								<div id="tala" class="kssmenu" data-value="LOLL">
									<span class="kssmenu_value">Dhruva</span>
                        
									<div class="kssmenu_options" data-width="span2" style="max-height:320px;overflow-y:scroll;">
										<div>
											<b>Sapta talas</b>
										</div>
                            
										<div>
											<a data-value="LOLL" data-selected="yes">Dhruva</a>
                                
											<a data-value="LOL">Matya</a>
                                
											<a data-value="OL">Rupaka</a>
                                
											<a data-value="LUO">Jampa</a>
                                
											<a data-value="LOO">Triputa</a>
                                
											<a data-value="LLOO">Ata</a>
                                
											<a data-value="L">Eka</a>
                            
										</div>

                            
										<div>
											<b>108 talas</b>
										</div>
                            
										<div>
											<a data-value="GGLP">Chachchatputa</a>
                                
											<a data-value="GLLG">Chaachaputa</a>
                                
											<a data-value="PLGGLP">Shatpitaputrika</a>
                                
											<a data-value="PGGGP">Sampadveshtaka</a>
                                
											<a data-value="GGG">Udghatta</a>
                                
											<a data-value="L">Adi</a>
                                
											<a data-value="OOG">Darpana</a>
                                
											<a data-value="OOULOOULOOULOOLOOULOOLOOULOOUL">Charchaari</a>
                                
											<a data-value="LOOOL">Shimhalilaa</a>
                                
											<a data-value="OOLGG">Kandarpa</a>
                                
											<a data-value="GGGLPLGP">Simhavikrama</a>
                                
											<a data-value="LLGLP">Sriranga</a>
                                
											<a data-value="LGGL">Rati Lila</a>
                                
											<a data-value="OOOOG">Ranga Tala</a>
                                
											<a data-value="LLLGG">Parikramaa</a>
                                
											<a data-value="GGGLL">Pratyanga</a>
                                
											<a data-value="LLLLU">Gaja Lila</a>
                                
											<a data-value="LGP">Tribhinna</a>
                                
											<a data-value="LOG">Viravikrama</a>
                                
											<a data-value="LLU">Hamsa Lila</a>
                                
											<a data-value="OOLG">Varnabhina</a>
                                
											<a data-value="GGGLP">Rangadyotana</a>
                                
											<a data-value="OOLLLOOLG">Rajachudamani</a>
                                
											<a data-value="GPOGLP">Raja Tala</a>
                                
											<a data-value="LLPGLGPLP">Simhavikridita</a>
                                
											<a data-value="OOOOLOOG">Vanamaali</a>
                                
											<a data-value="GGLOOG">Chatusra Varna</a>
                                
											<a data-value="LOOLLG">Traysra Varna</a>
                                
											<a data-value="OOOOUOOOOUOOOOU">Misra Varna</a>
                                
											<a data-value="GGLGP">Ramgapradipa</a>
                                
											<a data-value="LLPDG">Hamsanaada</a>
                                
											<a data-value="LGGLG">Simbanaada</a>
                                
											<a data-value="LLOOOO">Mallikaamoda</a>
                                
											<a data-value="LLOOOLL">Sarabba Lila</a>
                                
											<a data-value="GGLLP">Rangaabharana</a>
                                
											<a data-value="OOL">Turanga Lila</a>
                                
											<a data-value="GGLPLGOOGGLPLPGLLK">Simhanandana</a>
                                
											<a data-value="GGLLG">Jayasri</a>
                                
											<a data-value="LLGGG">Vijayaananda</a>
                                
											<a data-value="LOO">Prati Tala</a>
                                
											<a data-value="OLO">Dvitiya</a>
                                
											<a data-value="OOLLLG">Maakaranda</a>
                                
											<a data-value="GLPGLG">Kirti</a>
                                
											<a data-value="GGGLG">Vijaya</a>
                                
											<a data-value="LGPLGP">Jayamangala</a>
                                
											<a data-value="LGOO">Raajavidyaadhara</a>
                                
											<a data-value="LLGLLLL">Mathya</a>
                                
											<a data-value="LGLLOO">Jaya</a>
                                
											<a data-value="OOLL">Kudukka</a>
                                
											<a data-value="LGG">Nissaaruka</a>
                                
											<a data-value="OOU">Kreeda</a>
                                
											<a data-value="LGLG">Tribhangi</a>
                                
											<a data-value="GLP">Kokilapriya</a>
                                
											<a data-value="GGLL">Srikeerthi</a>
                                
											<a data-value="GOOOOG">Bindumaali</a>
                                
											<a data-value="LLOOU">Sama Tala</a>
                                
											<a data-value="LOOP">Nandana</a>
                                
											<a data-value="LLG">Udeekshana</a>
                                
											<a data-value="GOP">Mattika</a>
                                
											<a data-value="GLG">Dhenkika</a>
                                
											<a data-value="OOLOO">Varnamattika</a>
                                
											<a data-value="LLOOG">Abhinandana</a>
                                
											<a data-value="OOOU">Antarakreeda</a>
                                
											<a data-value="LLLLOOU">Malla Tala</a>
                                
											<a data-value="OOLLGG">Deepaka</a>
                                
											<a data-value="LPLLG">Ananga</a>
                                
											<a data-value="OOOOUOOOOU">Vishama</a>
                                
											<a data-value="LOOLLG">Nandi</a>
                                
											<a data-value="LOOLG">Mukunda</a>
                                
											<a data-value="LLLLG">Kanduka</a>
                                
											<a data-value="O">Eka Tala</a>
                                
											<a data-value="LOOL">Ata Tala</a>
                                
											<a data-value="OOOOGL">Poorna Kankaala</a>
                                
											<a data-value="OOGG">Khanda Kankaala</a>
                                
											<a data-value="GGL">Sama Kankaala</a>
                                
											<a data-value="LGG">Vishama Kankaala</a>
                                
											<a data-value="GOOO">Chatus Tala</a>
                                
											<a data-value="LULU">Dombuli</a>
                                
											<a data-value="LP">Abhanga</a>
                                
											<a data-value="GLGOO">Raaya Vankola</a>
                                
											<a data-value="LU">Laghu Sekhara</a>
                                
											<a data-value="POOU">Prataapa Sekhara</a>
                                
											<a data-value="GOOOU">Jagajjhampa</a>
                                
											<a data-value="LGLG">Chaturmuka</a>
                                
											<a data-value="OOUL">Jhampa</a>
                                
											<a data-value="LLGGLL">Pratimatya</a>
                                
											<a data-value="OOOOOU">Gaarugi</a>
                                
											<a data-value="LLLGGG">Vasanta</a>
                                
											<a data-value="OOLG">Lalita</a>
                                
											<a data-value="LG">Rati Tala</a>
                                
											<a data-value="OOOO">Karana Yati</a>
                                
											<a data-value="GLLL">Yati</a>
                                
											<a data-value="OOOOOO">Shat tala</a>
                                
											<a data-value="OOLP">Vardhana</a>
                                
											<a data-value="LLPP">Varna yati</a>
                                
											<a data-value="OOLGLG">Raajanaaraayana</a>
                                
											<a data-value="OOP">Madana</a>
                                
											<a data-value="OOOOU">Kaarika</a>
                                
											<a data-value="OOLOOGGLLLLGLL">Paarvati Lochana</a>
                                
											<a data-value="GLLP">Srinandana</a>
                                
											<a data-value="OLP">Lila</a>
                                
											<a data-value="LGOOP">Vilokita</a>
                                
											<a data-value="LLGLL">Lalitapriya</a>
                                
											<a data-value="GOO">Jhallaka</a>
                                
											<a data-value="LLLLGGLLG">Janaka</a>
                                
											<a data-value="OOLLP">Lakshmisa</a>
                                
											<a data-value="OOUOP">Raagavardhana</a>
                                
											<a data-value="PL">Utsava</a>
                            
										</div>
                        
									</div>
                    
								</div>
                    tala in
                    
								<div id="nadai" class="kssmenu" data-value="_">
									<span class="kssmenu_value">Default (1)</span>
                        
									<div class="kssmenu_options">
										<a data-value="_" data-selected="yes">Default (1)</a>
                            
										<a data-value="__">Catusra (2)</a>
                            
										<a data-value="_,_">Tisra (3)</a>
                            
										<a data-value="____">Catusra (4)</a>
                            
										<a data-value="_,_,_">Kanda (5)</a>
                            
										<a data-value="_,__,_">Tisra (6)</a>
                            
										<a data-value="_,_,_,_">Misra (7)</a>
                            
										<a data-value="________">Catusra (8)</a>
                            
										<a data-value="_,_,_,_,_">Sankirna (9)</a>
                        
									</div>
                    
								</div>
                    nadai,
                    
								<div id="kalai" class="kssmenu" data-value="_">
									<span class="kssmenu_value">Oru</span>
                        
									<div class="kssmenu_options">
										<a data-value="_" data-selected="yes">Oru (1)</a>
                            
										<a data-value="__">Rendu (2)</a>
                        
									</div>
                    
								</div>
                    kalai, at a tempo of
                    
								<div id="tempo" class="kssmenu" data-value="80">
									<span class="kssmenu_value">80</span>
                        
									<div class="kssmenu_options" data-width="span1">
										<a data-value="15">15</a>
                            
										<a data-value="30">30</a>
                            
										<a data-value="40">40</a>
                            
										<a data-value="50">50</a>
                            
										<a data-value="60">60</a>
                            
										<a data-value="70">70</a>
                            
										<a data-value="80" data-selected="yes">80</a>
                            
										<a data-value="90">90</a>
                            
										<a data-value="100">100</a>
                            
										<a data-value="110">110</a>
                            
										<a data-value="120">120</a>
                            
										<a data-value="130">130</a>
                            
										<a data-value="140">140</a>
                        
									</div>
                    
								</div>
                    aksharas per minute.
                
							</div>
                
							<div>
								<a href="#" id="play35" class="btn btn-success btn-large span2">Play</a>
                    
								<span id="sys_tala_link" class="span2" hidden>( 
									<a href="#">shareable link</a> )
								</span>
                    
								<script>
                        (function () {
                            var activeMenu = null;

                            Array.prototype.forEach.call(document.querySelectorAll('#full_systematic_name div.kssmenu'), function (menu, i) {
                                var optionsGroup = menu.querySelector('.kssmenu_options');
                                var options = optionsGroup.querySelectorAll('a');
                                var valueDisplay = menu.querySelector('.kssmenu_value');
                                var widthClass = optionsGroup.dataset.width || 'span2';

                                menu.style.position = 'relative';
                                menu.style.display = 'inline-block';
                                optionsGroup.style.position = 'absolute';
                                optionsGroup.style.backgroundColor = 'white';
                                optionsGroup.style.border = 'solid lightgrey 2px';
                                optionsGroup.classList.add(widthClass);
                                valueDisplay.style.fontWeight = 'bolder';
                                optionsGroup.hidden = true;
                                valueDisplay.addEventListener('click', function () {
                                    if (activeMenu && activeMenu !== optionsGroup) {
                                        activeMenu.hidden = true;
                                    }
                                    optionsGroup.hidden = !optionsGroup.hidden;
                                    if (!optionsGroup.hidden) {
                                        activeMenu = optionsGroup;
                                        activeMenu.style.zIndex = 100;
                                    }
                                });

                                Array.prototype.forEach.call(options, function (option, j) {
                                    option.onclick = function (event) {
                                        debugger;
                                        menu.dataset.value = option.dataset.value;
                                        valueDisplay.innerHTML = option.innerHTML;
                                        optionsGroup.hidden = true;
                                        document.querySelector('#sys_tala_link').hidden = true;
                                    };
                                    option.classList.add(widthClass);
                                    option.style.color = '#00F';
                                    if (option.dataset.selected === 'yes') {
                                        option.onclick();
                                    }
                                });
                            });
                        }());
                    </script>
                
							</div>
            
						</div>


            
						<script>
                requirejs(['TK3'], function (TK3) {
                var TalaPlayer = TK3.setupPlayer({
                    width: 320, 
                    div: '#taladisplay',
                    label: '#talaname',
                    tempo: '#talatempo',
                    urldisplay: '#paste_to_convert'
                });

                (function () {

                    function processPatternList(sel) {
                        var links = document.querySelectorAll(sel + ' a');
                        var i, N = links.length, tala;
                        for (i = 0; i < N; ++i) {
                            tala = TK3.validateTalaURL(links[i].getAttribute('href'));
                            links[i].setAttribute('href', '#');
                            links[i].innerHTML = tala.name;
                            links[i].onclick = (function (tala) {
                                return function () {
                                    TalaPlayer.play(tala.url);
                                };
                            }(tala));
                        }
                    }

                    processPatternList('#common_talas');
                    processPatternList('#alankara_talas');

                    function talaSymToPat(sym, jati) {
                        return (sym.replace(/L/g, jati)                     // Laghu
                                   .replace(/O/g, 'lr')                     // Dhrutam
                                   .replace(/U/g, 'l')                      // Anu-dhrutam
                                   .replace(/G/g, 'l___r___')               // Guru
                                   .replace(/P/g, 'l___r___r___')           // Plutam
                                   .replace(/K/g, 'l___r___r___r___'));     // Kakapadam
                    }

                    function getCurrentSystematicTalaURL() {
                        var jati = document.getElementById('jati');
                        var tala = document.getElementById('tala');
                        var kalai = document.getElementById('kalai');
                        var nadai = document.getElementById('nadai');
                        var tempo = document.getElementById('tempo');

                        var sysname = (document.querySelector('#jati span.kssmenu_value').innerHTML
                            + ' jati '
                            + document.querySelector('#tala span.kssmenu_value').innerHTML
                            + ' tala'
                            + (kalai.dataset.value.length > 1
                                ? (' (' + kalai.dataset.value.length + ' kalai)')
                                : ''));

                        var url = ('tala://talakeeper.org/tk3'
                        + '?bpm=' + tempo.dataset.value
                        + '&pat=' + talaSymToPat(tala.dataset.value, jati.dataset.value)
                        + '&kal=' + kalai.dataset.value
                        + '&nad=' + nadai.dataset.value
                        + '&name=' + encodeURIComponent(sysname));

                        return url;
                    }

                    document.getElementById('play35').onclick = function () {
                        var talaURL = getCurrentSystematicTalaURL();
                        var httpTalaURL = talaURL.replace(/^tala:\/\//, 'http://');
                        var sys_tala_link = document.querySelector('#sys_tala_link');
                        sys_tala_link.querySelector('a').setAttribute('href', httpTalaURL);
                        sys_tala_link.hidden = false;
                        TalaPlayer.play(talaURL);
                    };

                }());

                document.body.addEventListener('paste', function (event) {
                    var http = TK3.tala2http(event.clipboardData.getData('text/plain'));
                    TalaPlayer.play(http);
                    setTimeout(function () { setSelectURL(http); }, 0);
                    event.cancelBubble = true;
                    return false;
                });
                });
            </script>
        
					</div>
        
					<div style="margin:1em">
						<small>
							<a href="http://appstore.com/talakeeper">Tala Keeper</a> lets you create
                such patterns and more.
						</small>
        
					</div>
        
					<small class="copyright">This player requires a recent version
            of Chrome or Safari to run, since it uses the 
						<a href="http://caniuse.com/audio-api">Web Audio API</a>.
            I&apos;ll improve its fidelity to the iOS app as much as I
            can.
					</small>
    
				</div>

			</div>

            
			<div class="row">
				<span class="span8">
					<ul class="breadcrumb">
						<li>
							<a href="index.html">A quick guide</a>
						</li>
						<li>
							<span class="divider">|</span>
						</li>
						<li>
							<a href="tk3">Player</a>
						</li>
						<li>
							<span class="divider">|</span>
						</li>
						<li>
							<span class="thispage">Talas</span>
						</li>
						<li>
							<span class="divider">|</span>
						</li>
						<li>
							<a href="notes.html">Notes</a>
						</li>
						<li>
							<span class="divider">|</span>
						</li>
                    
						<li>
							<a href="/community">Community</a>
						</li>
                
					</ul>
            
				</span>
            
				<span class="span4 copyright">© 2013 and Tala Keeper™ 
					<a href="https://plus.google.com/102694714835839603248?rel=author">Srikumar Subramanian</a>
				</span>
        
			</div>
        
		</div>
    
	</body>

</html>